precision lowp int; 
precision lowp float; 


//Passed through from the VS
varying lowp vec4 uvs;
varying lowp vec3 worldnormal;
varying lowp vec4 vertexcolour;
varying mediump vec3 worldpos;



//Various uniforms ahoy
uniform sampler2D IN_texture_diffuse;

    
#if defined(USE_SPECULAR)
uniform sampler2D IN_texture_skymap_specular;
#endif


const int MAX_SUNS = 3;

uniform mediump vec3 IN_scene_eye_pos;
uniform lowp vec3 IN_scene_eye_dir;
uniform lowp float IN_scene_ambientscale;

uniform lowp float IN_material_specpow;
uniform lowp float IN_material_speclevel;
uniform lowp float IN_material_ambientscale;

uniform lowp vec3  IN_material_ambientcolour;





#if defined(USE_SPECULAR)
lowp vec2 DoImageBasedSpecular(lowp vec3 reflect)
{   
	return vec2(  ((atan(reflect.z,reflect.x) * 0.1591549430))+0.5 ,  (-reflect.y * 0.5) +0.5 );
}
#endif


void main() 
{
   
#if defined(USE_DIFFUSE_TEXTURE)

   lowp vec4 diffuseSample = texture2D(IN_texture_diffuse, uvs.xy);
   lowp vec4 diffuse= diffuseSample * vertexcolour;
#else
   lowp vec4 diffuse= vertexcolour;
#endif



#if defined(USE_SPECULAR)
    //dependent texture reads and a bunch of normalizes are bad too!
    lowp vec3 reflectVector = -normalize( reflect( normalize(IN_scene_eye_pos - worldpos), worldnormal ));
    lowp vec2 specularLightUV = DoImageBasedSpecular(reflectVector);
    lowp vec3 specularAccumulation = texture2D(IN_texture_skymap_specular, specularLightUV).xyz * IN_material_speclevel;
#endif



    //Gather
#if defined(USE_SPECULAR)
    gl_FragColor.xyz = (diffuse.xyz) + specularAccumulation;
#else
    gl_FragColor.xyz = diffuse.xyz;
#endif 
    
    
    
    gl_FragColor.w = diffuse.w;
    
}
